# fedcord

👾 Make Discord Great ̶A̶g̶a̶in for once

## Why?

Discord was never a friend to begin with. However, if you are going to use such an evil service, at least do so any better? You **should** have a better experience with the following modifications. It's called `fedcord` because I don't trust it anymore than I already did.

## Roadmap

*Updated: ~Thur, July 18th 2022 at 21:30:00 MST*

#### Milestone Summary:

| Status | Goal |
| :---: | :--- |
| ✅ | [Repo initialization](https://git.tcp.direct/milkyquest/fedcord) |
| 🚫 | Add preview images |

## Getting Started

### Prerequisites

In-order for any of this to work, you'll need the following:

- **A Brain**: Shouldn't be hard to follow along? Didn't think this needed automation.
- **Discord Canary**: Yes; [Canary](https://support.discord.com/hc/nl/articles/360035675191-Discord-Testing-Clients), or also known as the alpha version, needs to be installed.
- **git**, **node**, **yarn**: This is an [Electron](https://www.electronjs.org/) desktop app we're modding after all? 

If the following is acquired, feel free to follow along!

## Discord 

As stated above, Discord Canary must be installed on your system before proceeding. I included a [`PKGBUILD`](canary/PKGBUILD) file for building it from source within the directory titled `canary`. Simply check out [`INFO.md`](canary/INFO.md) and determine how you want to approach the installation yourself. 

## OpenAsar

Would recommend doing this prior to starting the client. 😏

First, let's replace discord's `app.asar` file (`$ whereis discord-canary`) with [OpenAsar](https://github.com/GooseMod/OpenAsar) for better performance and privacy. You might be best following the instructions from there, as I'll only briefly elaborate here. 

1) Download [this](https://github.com/GooseMod/OpenAsar/releases/download/nightly/app.asar) anyhow 
2) Backup old `app.asar` file

```
sudo mv /opt/discord-canary/resources/app.asar /opt/discord-canary/resources/app.asar.bk
```

3) Replace with the new one, just downloaded

```
sudo mv ~/Downloads/app.asar /opt/discord-canary/resources
```

4) Start the client, you should be greeted with a window after the splash screen, asking you to choose some options before retarting and launching for the first time!

## Powercord 

Instead of going through the hassle of installing [BetterDiscord](https://betterdiscord.app/) installers and all of that nonsense, let me save you the trouble. We'll be installing [Powercord](https://powercord.dev/), a powerful client mod which will further allow us to do everything we'd want to do as a user.

1) Clone the repository, cd into it, install deps, then run the script to inject your client.

```cmd
git clone https://github.com/powercord-org/powercord $HOME/.config/powercord

cd $HOME/.config/powercord

yarn

yarn run plug

# 🚨 Make sure the discord process is killed
# 🚨 Open it up, check that it's injected 💉
```

## Plugins

Now let's get to the fun stuff, adding and playing with plugins! The directory we created for Powercord within `.config` is a bit too nesty for my taste, if we're being honesty here. It will leave you with a `src` dir and a `Powercord` dir inside of that. There we can find our `plugins` and `themes` directories!

1) cd into the Powercord plugins directory, clone plugins

```cmd
cd $HOME/.config/powercord/src/Powercord/plugins

git clone https://git.tcp.direct/milky/pc-redirect

git clone https://git.tcp.direct/milky/pc-unindent

git clone https://git.tcp.direct/milky/pc-nitro

git clone https://github.com/Juby210/bdCompat
```

2) Move the only BetterDiscord plugin recommend [HideChannels.plugin.js](HideChannels.plugin.js) to `$HOME/.config/powercord/src/Powercord/plugins/bdCompat/plugins`

## Themes

1) Similar to the steps above, cd into the Powercord `themes` directory then clone the following themes


```cmd
cd $HOME/.config/powercord/src/Powercord/themes

git clone https://git.tcp.direct/milky/pc-milked

git clone https://git.tcp.direct/milky/pc-emojis

git clone https://git.tcp.direct/milky/pc-hljs

git clone https://git.tcp.direct/milky/pc-bottom
```

## Personalize

Make any changes you wish to make from here on out, experiment crazily! 🍀